﻿<AML>
 <Item type="Method" id="F980DDC886B540C696D5EFED01047DD9" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[            /* *****************************************************************************
                                    Method Name:			AddStock
                                    Created By/Company:		Sandar 
                                    Creation Date:			2019-03-28
                                    Description:
                                       Creating stocks for Existing Parts and its BOM.

                                    Hooks:
                                        Called by:  Create_new_Stock Method

                                    Inputs:
                                        <describe the inputs expected by the server method>

                                    Revisions:
                                        Rev Date		Modified By			Description
                                        YYYY-MM-DD		***					Initial creation
                                    ***************************************************************************** */

            //WARNING: DO NOT FORGET TO DISABLE THIS IN A PRODUCTION ENVIRONMENT!!!
            //if (System.Diagnostics.Debugger.Launch()) System.Diagnostics.Debugger.Break();

            string MethodName = "AddStock";

            //***** GRANT IDENTITY PRIVILEGES
            // grantIdentityPrivileges("Super User"); // If this is enabled always revoke the privileges in the Finally below.
            //*******************************
            Innovator myInnovator = this.getInnovator();
            Item result = this; // default return value.

            try
            {
                var year = "2014";
                StringBuilder sb_get_released_part = new StringBuilder("");
                sb_get_released_part.Append(" SELECT * ");
                sb_get_released_part.Append(" FROM innovator.part");
                sb_get_released_part.Append(" WHERE state = 'Released'");
                sb_get_released_part.Append(" and is_current = 1");
                sb_get_released_part.Append(" and CREATED_ON like '%" + year + "%'");
                sb_get_released_part.Append(" order by created_on");
                string sql_get_released_part = sb_get_released_part.ToString();
                Item get_released_part = myInnovator.applySQL(sql_get_released_part);
                var released_part_count = get_released_part.getItemCount();

                for (int i = 0; i < get_released_part.getItemCount(); i++)
                {
                    Item get_released_part_item = get_released_part.getItemByIndex(i);
                    string part_id = get_released_part_item.getID();

                    Item assemblyItem = myInnovator.newItem("Part", "get");
                    assemblyItem.setAttribute("select", "keyed_name,item_number,description,unit,major_rev,name,thumbnail,cost");
                    assemblyItem.setID(part_id);
                    Item bomItem = myInnovator.newItem("Part BOM", "get");
                    bomItem.setAttribute("select", "major_rev,related_id(keyed_name)");
                    bomItem.setAttribute("orderby", "sort_order");
                    assemblyItem.addRelationship(bomItem);
                    assemblyItem = assemblyItem.apply();
                    if (!assemblyItem.isError())
                    {
                        // Item bomItems = assemblyItem.getRelationships();
                        //  int bomItemsCount = bomItems.getItemCount();

                        Item add_stock_result = AddStockRecursive(myInnovator, assemblyItem);
                        if (add_stock_result.isError())
                        {
                            return myInnovator.newError(add_stock_result.getErrorString());
                        }
                    }
                }
            }
            catch (System.Exception ex)
            {
                 return myInnovator.newError( MethodName + "\n" + ex.Message);
            }
            finally
            {

            }

            return result;
        }
        /// <summary>
        /// This section is to allow the current method to assume the privileges of a specific identity.
        /// For instance calling: grantIdentityPrivileges("Aras PLM"); will allow this method all of the
        /// rights of the Aras PLM identity.
        /// The revokeIdentityPrivileges() method will removed the privileges added for this method. It
        /// must be called from before the method exits. Most likely in the Finally of the main method code.
        /// If different identity privileges must be granted a second time within the same method, first use
        /// revokeIdentityPrivileges() to remove the first privileges before granting new ones.
        /// </summary>

        private string AssignedIdentity;

        /// <summary>
        /// If required, call this helper function to run this method as another Identity. 
        /// Ensure that you call the revokeIdentityPrivileges helper function in the 
        /// finally block to revoke the Identity privilege when this method completes.
        /// </summary>
        public void grantIdentityPrivileges(string assignedIdent)
        {
            if (!string.IsNullOrEmpty(AssignedIdentity))
            {
                revokeIdentityPrivileges();
            }

            Aras.Server.Security.Identity secIdentity = Aras.Server.Security.Identity.GetByName(assignedIdent);
            if (Aras.Server.Security.Permissions.GrantIdentity(secIdentity))
            {
                AssignedIdentity = assignedIdent;
            }
        }

        /// <summary>
        /// If you granted security privileges, then you need to ensure that you revoke the privilege.
        /// </summary>
        public void revokeIdentityPrivileges()
        {
            if (AssignedIdentity != null)
            {
                Aras.Server.Security.Permissions.RevokeIdentity(Aras.Server.Security.Identity.GetByName(AssignedIdentity));
                AssignedIdentity = null;
            }
        }
        public static Item AddStockRecursive(Innovator myInnovator, Item partItem)
        {
            string UOM_ID = "";
            string itemID = partItem.getID();

            string itemTypeName = partItem.getType();
            string itemKeyedName = partItem.getProperty("keyed_name", "");

            /**to check stock **/
            Item check_stock = myInnovator.newItem("stk_stock_setup", "get");
            check_stock.getAttribute("select", "id");
            check_stock.setProperty("keyed_name", itemKeyedName);
            check_stock.setPropertyCondition("keyed_name", "eq");

            Item results_stock = check_stock.apply();
            Item Newstock_Item_result = myInnovator.newItem("", "");
            if (results_stock.isError())
            {   

                /** add stock **/
                string PartId = partItem.getProperty("id", "");
                string Item_Number = partItem.getProperty("item_number", "");
                string Description = partItem.getProperty("description", "");
                string name = partItem.getProperty("name", "");
                string thumbnail_pic = partItem.getProperty("thumbnail", "");
                string Unit = partItem.getProperty("unit", "");
                string Major_REV = partItem.getProperty("major_rev", "");
                string cost = partItem.getProperty("cost", "");
                if (cost == "")
                {
                    cost = "0";
                }
                Item Stock_UOM = myInnovator.newItem("stk_UOM", "get");
                Stock_UOM.setProperty("keyed_name", Unit);
                Stock_UOM = Stock_UOM.apply();
                if (Stock_UOM.getItemCount() > 0)
                {
                    UOM_ID = Stock_UOM.getID();
                }
                Item newStock = myInnovator.newItem("stk_stock_setup", "add");
                newStock.setProperty("stk_code", itemKeyedName);
                newStock.setProperty("part_no", PartId);
                newStock.setProperty("stk_description", Description);
                newStock.setProperty("stk_name", name);
                newStock.setProperty("thumbnail", thumbnail_pic);
                newStock.setProperty("stk_uom", UOM_ID);
                newStock.setProperty("stk_rev", Major_REV);
                newStock.setProperty("stk_price", cost);
                newStock.setProperty("stk_cost", cost);

                /** add stock location **/
                var newLocation = myInnovator.newItem("stk_stock_location", "add");
                // newLocation.setProperty("source_id", stock_id);
                newLocation.setProperty("stk_holding_qty", "0.0");
                newLocation.setProperty("stk_indicator", "#FFFFFF");
                newLocation.setProperty("stk_min_qty", "0.0");
                newLocation.setProperty("stk_reserved_qty", "0.0");

                var defaultLocation = myInnovator.newItem("stk_location", "get");
                defaultLocation.setProperty("stk_location_default", "1");
                var stk_location = defaultLocation.apply();

                if (stk_location.getItemCount() > 0)
                {
                    // defaultLocation = stk_location.getItemByIndex(0);
                    newLocation.setRelatedItem(stk_location);

                    /** add relationship of stock location **/
                    newStock.addRelationship(newLocation);
                    if (newStock.isError())
                    {
                        return myInnovator.newError("Error : add_allpartBOM_to_Stock method.");
                    }
                }

                Newstock_Item_result = newStock.apply();
                if (Newstock_Item_result.isError())
                {
                    return myInnovator.newError(Newstock_Item_result.getErrorString());

                }

            }
            Item qryItem = myInnovator.newItem("Part", "get");
            qryItem.setAttribute("select", "keyed_name,item_number,description,unit,major_rev,name,thumbnail,cost");
            qryItem.setID(partItem.getID());

            // Add the BOM structure.
            Item bomItem = myInnovator.newItem("Part BOM", "get");
            bomItem.setAttribute("select", "major_rev,related_id(keyed_name,item_number,description,name,thumbnail,unit,major_rev,cost)");
            bomItem.setAttribute("orderby", "sort_order");
            qryItem.addRelationship(bomItem);

            // Perform the query.
            Item results = qryItem.apply();
            // Test for an error.
            if (!results.isError())
            {
                // Get a handle to the BOM Items.
                Item bomItems = results.getRelationships();
                int bomItemsCount = bomItems.getItemCount();
                for (int i = 0; i < bomItemsCount; ++i)
                {
                    Item bom = bomItems.getItemByIndex(i);
                    Item bomPart = bom.getRelatedItem();
                    AddStockRecursive(myInnovator, bomPart);

                }
            }
            return Newstock_Item_result;]]></method_code>
  <method_type>C#</method_type>
  <name>AddStock</name>
 </Item>
</AML>